package com.ruoyi.system.service;

import java.util.List;
import com.ruoyi.system.domain.SysUserNotification;
import com.ruoyi.system.domain.dto.SysNotificationDto;
import com.ruoyi.system.domain.dto.WorkLikeDto;
import com.ruoyi.system.domain.vo.UserMessageVo;

/**
 * 用户消息通知Service接口
 * 
 * @author haotian
 * @date 2024-12-02
 */
public interface ISysUserNotificationService 
{
    /**
     * 查询用户消息通知
     * 
     * @param id 用户消息通知主键
     * @return 用户消息通知
     */
    public SysUserNotification selectSysUserNotificationById(Long id);

    /**
     * 查询用户消息通知列表
     * 
     * @param sysUserNotification 用户消息通知
     * @return 用户消息通知集合
     */
    public List<SysUserNotification> selectSysUserNotificationList(SysUserNotification sysUserNotification);

    /**
     * 新增用户消息通知
     * 
     * @param sysUserNotification 用户消息通知
     * @return 结果
     */
    public int insertSysUserNotification(SysUserNotification sysUserNotification);

    /**
     * 修改用户消息通知
     * 
     * @param sysUserNotification 用户消息通知
     * @return 结果
     */
    public int updateSysUserNotification(SysUserNotification sysUserNotification);

    /**
     * 批量删除用户消息通知
     * 
     * @param ids 需要删除的用户消息通知主键集合
     * @return 结果
     */
    public int deleteSysUserNotificationByIds(Long[] ids);

    /**
     * 删除用户消息通知信息
     * 
     * @param id 用户消息通知主键
     * @return 结果
     */
    public int deleteSysUserNotificationById(Long id);

    UserMessageVo getUserMessages(Long userId);

    public List<SysUserNotification> unreadNotifiaction(Long userId);

    /*
    * 查看新增关注数
    * */
    public Long getAddFollowerCount(Long userId);

    /*
    * 查看新增点赞数
    * */
    public Long getAddLikeCount(Long userId);

    /*
    * 读消息
    * */
    public Long readNotifiaction(Long userId, String type, String status);

    /*
    * 消息--查看系统消息
    * */
    public List<SysNotificationDto> getSystemMessage(Long userId);

    /*
    * 消息--查看点赞消息列表
    * */
    public List<WorkLikeDto> getWorkLikeList(Long userId);

    /*
    * 注销账户是 删除通知数据
    * */
    public int deleteSysUserNotificationBySenderId(Long userId);


    /**
     * 取消关注时删除关注通知
     *
     */
    public int deleteSysUserNotificationBySenderIdAndUserId(Long userId, Long followedUserId, String type);
}
